<%--<!--
 ~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->--%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
           prefix="carbon" %>

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page
        import="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.GadgetRepoServiceClient" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.Gadget" %>
<%@ page import="org.apache.axiom.om.util.Base64" %>
<%
    String backendServerURL = CarbonUIUtil.getServerURL(config
            .getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config
            .getServletContext().getAttribute(
                    CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session
            .getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    GadgetRepoServiceClient gadgetRepoServiceClient = new GadgetRepoServiceClient(cookie,
            backendServerURL,
            configContext,
            request.getLocale());

    String param = request.getParameter("mode");
    String gadgetPath = request.getParameter("gadgetPath");
    String uploadedGadgetPath = request.getParameter("ugPath");

    String errMsg = request.getParameter("msg");

    Gadget result = null;
    if ("mod".equals(param)) {
        result = gadgetRepoServiceClient.getGadget(gadgetPath);
    }

    if (uploadedGadgetPath == null || "".equals(uploadedGadgetPath)) {
        uploadedGadgetPath = "";
    }

%>

<script type="text/javascript" src="../yui/build/yahoo/yahoo-min.js"></script>
<script type="text/javascript"
        src="../yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript"
        src="../yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="javascript/gadgetrepo-server-utils.js"></script>
<script type="text/javascript" src="javascript/gadgetrepo-service-stub.js"></script>
<script type="text/javascript" src="javascript/jquery-1.3.2.min.js"></script>
<script type="text/javascript" src="javascript/jquery-ui-1.6.custom.min.js"></script>

<script type="text/javascript">
    <%if(errMsg != null){%>
    CARBON.showErrorDialog('<%=errMsg%>');
    <% } %>

    function showInput(opt) {
        if (opt == 1) {
            $('#uploadTr').show();
            $('#urlTr').hide();
        } else if (opt == 2) {
            $('#uploadTr').hide();
            $('#urlTr').show();
        }
    }

    function validateForm() {
        if ($('#gadgetName').val() == "") {
            CARBON.showErrorDialog('Please insert a name for the gadget');
        } else {
            $('#gadgetForm').submit();
        }
    }
</script>

<fmt:bundle
        basename="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.resource.i18n.Resources">
    <carbon:jsi18n
            resourceBundle="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.resource.i18n.JSResources"
            request="<%=request%>"/>
    <carbon:breadcrumb label="Add / Modify Gadget"
                       resourceBundle="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.resource.i18n.Resources"
                       topPage="false" request="<%=request%>"/>
    <div id="middle">
        <div id="workArea">
            <div id="dcontainer"></div>
            <%
                if ("add".equals(param)) {
            %>
            <form action="../../fileupload/gadgetupload"
                  enctype="multipart/form-data" method="post" id="gadgetForm">
                <input type="hidden" id="uMode" name="mode" value="<%=param%>"/>
                <input id="uResourceMediaType" type="hidden" name="mediaType"
                       value="application/vnd.wso2.gs.gadget"/>
                <input type="hidden" id="redirect" name="redirect" value="gadgetrepo/index.jsp"/>
                <input type="hidden" id="errorRedirect" name="errorRedirect" value="gadgetrepo/add-gadget.jsp"/>
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key="new.gadget.info"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                        <td class="formRow">

                            <table class="normal">
                                <tbody>
                                <tr>
                                    <td><label><fmt:message key="gadget.name"/></label><span
                                            class="required">&nbsp;* </span></td>
                                    <td><input type="text" size="50" name="gadgetName"
                                               id="gadgetName"/></td>
                                </tr>

                                <tr id="urlTr">
                                    <td><label><fmt:message key="gadget.url"/></label><span
                                            class="required">&nbsp;* </span></td>
                                    <td><input type="text" size="50" name="gadgetUrl"
                                               id="gadgetUrl" value="<%=uploadedGadgetPath%>"/></td>
                                    <td><a href="javascript:showInput(1);">+ Upload Gadget Xml</a></td>
                                </tr>
                                <tr style="display:none;" id="uploadTr">
                                    <td><label>Gadget File/Archive</label></td>
                                    <td><input type="file" size="50" name="gadget"
                                               id="gadget"/></td>
                                    <td><a href="javascript:showInput(2);">- Add By URL</a></td>
                                </tr>
                                <tr>
                                    <td><label><fmt:message key="gadget.description"/></label></td>
                                    <td><textarea rows="5" cols="48" name="gadgetDesc"
                                                  id="gadgetDesc"></textarea></td>
                                </tr>

                                <tr>
                                    <td><label><fmt:message key="gadget.sceenshot"/></label></td>
                                    <td><input type="file" size="50" name="gadgetScreen"
                                               id="gadgetScreen"/></td>
                                </tr>

                                </tbody>
                            </table>

                        </td>
                    </tr>
                    <tr>
                        <td class="buttonRow"><input type="button" onclick="validateForm()"
                                                     value="<fmt:message key="add.gadget.button"/>" class="button"
                                                     id="addGadget"/></td>
                    </tr>
                    </tbody>
                </table>
            </form>
            <%
            } else {
            %>
            <form action="../../fileupload/gadgetupload"
                  enctype="multipart/form-data" method="post" id="gadgetForm">
                <input type="hidden" id="uMode" name="mode" value="<%=param%>"/>
                <input id="uResourceMediaType" type="hidden" name="mediaType"
                       value="application/vnd.wso2.gs.gadget"/>
                <input type="hidden" id="redirect" name="redirect" value="gadgetrepo/index.jsp"/>
                <input type="hidden" id="errorRedirect" name="errorRedirect" value="gadgetrepo/add-gadget.jsp"/>
                <input type="hidden" id="gadgetPath" name="gadgetPath" value="<%=gadgetPath%>"/>
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key="modify.gadget.info"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                        <td class="formRow">

                            <table class="normal">
                                <tbody>
                                <tr>
                                    <td><label><fmt:message key="gadget.name"/></label><span
                                            class="required">&nbsp;* </span></td>
                                    <td><input type="text" size="50" name="gadgetName"
                                               id="gadgetName" value="<%=result.getGadgetName()%>"/></td>
                                </tr>

                                <tr>
                                    <td><label><fmt:message key="gadget.url"/></label><span
                                            class="required">&nbsp;* </span></td>
                                    <td><input type="text" size="50" name="gadgetUrl"
                                               id="gadgetUrl" value="<%=result.getGadgetUrl()%>"/></td>
                                </tr>

                                <tr>
                                    <td><label><fmt:message key="gadget.description"/></label></td>
                                    <td><textarea rows="5" cols="38" name="gadgetDesc"
                                                  id="gadgetDesc"><%=result.getGadgetDesc()%>
                                    </textarea></td>
                                </tr>

                                <tr>
                                    <td><label><fmt:message key="gadget.sceenshot"/></label></td>
                                    <td><input type="file" size="50" name="gadgetScreen"
                                               id="gadgetScreen"/></td>
                                    <td>
                                        <%
                                            if (result.getGadgetScreenBase64() != null
                                                    && !result.getGadgetScreenBase64()
                                                    .equals("")) {
                                        %>
                                        <div id="imageIco">
                                            <img style="" id="imageIcon"
                                                 src="image-ajaxprocessor.jsp?gadgetPath=<%=gadgetPath%>"
                                                 width="100px" height="100px" class="gadgetImage"/><br/><br/>
                                            <a href="javascript:removeImage('<%=gadgetPath%>')" accesskey=""
                                               id="rmLink">Remove
                                                Image</a>
                                        </div>
                                        <%
                                        } else {
                                        %> <img id="imageIcon" src="images/no-image.jpg" width="100px"
                                                height="100px" class="gadgetImage"/>
                                        <%
                                            }
                                        %>

                                    </td>
                                </tr>

                                </tbody>
                            </table>

                        </td>
                    </tr>
                    <tr>
                        <td class="buttonRow"><input type="button" onclick="validateForm()"
                                                     value="<fmt:message key="modify.gadget.button"/>" class="button"
                                                     id="modifyGadget"/></td>
                    </tr>
                    </tbody>
                </table>
            </form>
            <%
                }
            %>
        </div>

    </div>
</fmt:bundle>